# coding: utf-8

"""
    WakaTime API

    REST API for accessing your WakaTime coding activity stats. - Uses GET for retrieval, POST/PUT/PATCH for modification. - All requests must use HTTPS. - Responses are JSON objects. Data is in the `data` key, errors in `error` or `errors`. - Refer to WakaTime usage guidelines when using the trademark or logo.   # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from wakatime_api.api_client import ApiClient


class DurationsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_current_user_durations(self, _date, **kwargs):  # noqa: E501
        """Get Current User Durations  # noqa: E501

        Retrieve the currently authenticated user's coding activity durations for a specific day.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_durations(_date, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param date _date: Date in YYYY-MM-DD format. (required)
        :param str project: Filter by project name.
        :param str branches: Filter by comma-separated list of branch names.
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :param str timezone: Override the user's timezone (Olson format, e.g., 'America/Los_Angeles').
        :param str slice_by: Primary key for slicing durations.
        :return: DurationsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_current_user_durations_with_http_info(_date, **kwargs)  # noqa: E501
        else:
            (data) = self.get_current_user_durations_with_http_info(_date, **kwargs)  # noqa: E501
            return data

    def get_current_user_durations_with_http_info(self, _date, **kwargs):  # noqa: E501
        """Get Current User Durations  # noqa: E501

        Retrieve the currently authenticated user's coding activity durations for a specific day.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_durations_with_http_info(_date, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param date _date: Date in YYYY-MM-DD format. (required)
        :param str project: Filter by project name.
        :param str branches: Filter by comma-separated list of branch names.
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :param str timezone: Override the user's timezone (Olson format, e.g., 'America/Los_Angeles').
        :param str slice_by: Primary key for slicing durations.
        :return: DurationsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['_date', 'project', 'branches', 'timeout', 'writes_only', 'timezone', 'slice_by']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_current_user_durations" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '_date' is set
        if ('_date' not in params or
                params['_date'] is None):
            raise ValueError("Missing the required parameter `_date` when calling `get_current_user_durations`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if '_date' in params:
            query_params.append(('date', params['_date']))  # noqa: E501
        if 'project' in params:
            query_params.append(('project', params['project']))  # noqa: E501
        if 'branches' in params:
            query_params.append(('branches', params['branches']))  # noqa: E501
        if 'timeout' in params:
            query_params.append(('timeout', params['timeout']))  # noqa: E501
        if 'writes_only' in params:
            query_params.append(('writes_only', params['writes_only']))  # noqa: E501
        if 'timezone' in params:
            query_params.append(('timezone', params['timezone']))  # noqa: E501
        if 'slice_by' in params:
            query_params.append(('slice_by', params['slice_by']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/current/durations', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DurationsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_durations(self, user, _date, **kwargs):  # noqa: E501
        """Get User Durations  # noqa: E501

        Retrieve a user's coding activity durations for a specific day. Durations are read-only representations of Heartbeats joined together based on the timeout setting.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_durations(user, _date, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param date _date: Date in YYYY-MM-DD format. (required)
        :param str project: Filter by project name.
        :param str branches: Filter by comma-separated list of branch names.
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :param str timezone: Override the user's timezone (Olson format, e.g., 'America/Los_Angeles').
        :param str slice_by: Primary key for slicing durations.
        :return: DurationsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_durations_with_http_info(user, _date, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_durations_with_http_info(user, _date, **kwargs)  # noqa: E501
            return data

    def get_user_durations_with_http_info(self, user, _date, **kwargs):  # noqa: E501
        """Get User Durations  # noqa: E501

        Retrieve a user's coding activity durations for a specific day. Durations are read-only representations of Heartbeats joined together based on the timeout setting.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_durations_with_http_info(user, _date, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param date _date: Date in YYYY-MM-DD format. (required)
        :param str project: Filter by project name.
        :param str branches: Filter by comma-separated list of branch names.
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :param str timezone: Override the user's timezone (Olson format, e.g., 'America/Los_Angeles').
        :param str slice_by: Primary key for slicing durations.
        :return: DurationsResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user', '_date', 'project', 'branches', 'timeout', 'writes_only', 'timezone', 'slice_by']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_durations" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user' is set
        if ('user' not in params or
                params['user'] is None):
            raise ValueError("Missing the required parameter `user` when calling `get_user_durations`")  # noqa: E501
        # verify the required parameter '_date' is set
        if ('_date' not in params or
                params['_date'] is None):
            raise ValueError("Missing the required parameter `_date` when calling `get_user_durations`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user' in params:
            path_params['user'] = params['user']  # noqa: E501

        query_params = []
        if '_date' in params:
            query_params.append(('date', params['_date']))  # noqa: E501
        if 'project' in params:
            query_params.append(('project', params['project']))  # noqa: E501
        if 'branches' in params:
            query_params.append(('branches', params['branches']))  # noqa: E501
        if 'timeout' in params:
            query_params.append(('timeout', params['timeout']))  # noqa: E501
        if 'writes_only' in params:
            query_params.append(('writes_only', params['writes_only']))  # noqa: E501
        if 'timezone' in params:
            query_params.append(('timezone', params['timezone']))  # noqa: E501
        if 'slice_by' in params:
            query_params.append(('slice_by', params['slice_by']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/{user}/durations', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DurationsResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
