# coding: utf-8

"""
    WakaTime API

    REST API for accessing your WakaTime coding activity stats. - Uses GET for retrieval, POST/PUT/PATCH for modification. - All requests must use HTTPS. - Responses are JSON objects. Data is in the `data` key, errors in `error` or `errors`. - Refer to WakaTime usage guidelines when using the trademark or logo.   # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from wakatime_api.api_client import ApiClient


class LeaderboardsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_current_user_private_leaderboard_leaders(self, board, **kwargs):  # noqa: E501
        """Get Current User's Private Leaderboard Leaders  # noqa: E501

        Retrieve the ranked list of members for a private leaderboard the current user belongs to.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_private_leaderboard_leaders(board, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str board: Private Leaderboard ID. (required)
        :param str language: Filter by language name.
        :param str country_code: Filter by two-character country code.
        :param int page: Page number for paginated results.
        :return: PrivateLeaderboardLeadersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_current_user_private_leaderboard_leaders_with_http_info(board, **kwargs)  # noqa: E501
        else:
            (data) = self.get_current_user_private_leaderboard_leaders_with_http_info(board, **kwargs)  # noqa: E501
            return data

    def get_current_user_private_leaderboard_leaders_with_http_info(self, board, **kwargs):  # noqa: E501
        """Get Current User's Private Leaderboard Leaders  # noqa: E501

        Retrieve the ranked list of members for a private leaderboard the current user belongs to.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_private_leaderboard_leaders_with_http_info(board, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str board: Private Leaderboard ID. (required)
        :param str language: Filter by language name.
        :param str country_code: Filter by two-character country code.
        :param int page: Page number for paginated results.
        :return: PrivateLeaderboardLeadersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['board', 'language', 'country_code', 'page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_current_user_private_leaderboard_leaders" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'board' is set
        if ('board' not in params or
                params['board'] is None):
            raise ValueError("Missing the required parameter `board` when calling `get_current_user_private_leaderboard_leaders`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'board' in params:
            path_params['board'] = params['board']  # noqa: E501

        query_params = []
        if 'language' in params:
            query_params.append(('language', params['language']))  # noqa: E501
        if 'country_code' in params:
            query_params.append(('country_code', params['country_code']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/current/leaderboards/{board}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PrivateLeaderboardLeadersResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_leaders(self, **kwargs):  # noqa: E501
        """Get Public Leaders  # noqa: E501

        Retrieve the public leaderboard, ranking users by coding activity. Updates periodically.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_leaders(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str language: Filter by language name.
        :param bool is_hireable: Filter leaders by hireable status.
        :param str country_code: Filter by two-character country code.
        :param int page: Page number for paginated results.
        :return: LeadersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_leaders_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_leaders_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_leaders_with_http_info(self, **kwargs):  # noqa: E501
        """Get Public Leaders  # noqa: E501

        Retrieve the public leaderboard, ranking users by coding activity. Updates periodically.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_leaders_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str language: Filter by language name.
        :param bool is_hireable: Filter leaders by hireable status.
        :param str country_code: Filter by two-character country code.
        :param int page: Page number for paginated results.
        :return: LeadersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['language', 'is_hireable', 'country_code', 'page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_leaders" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'language' in params:
            query_params.append(('language', params['language']))  # noqa: E501
        if 'is_hireable' in params:
            query_params.append(('is_hireable', params['is_hireable']))  # noqa: E501
        if 'country_code' in params:
            query_params.append(('country_code', params['country_code']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/leaders', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LeadersResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_private_leaderboard_leaders(self, user, board, **kwargs):  # noqa: E501
        """Get Private Leaderboard Leaders  # noqa: E501

        Retrieve the ranked list of members within a specific private leaderboard.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_private_leaderboard_leaders(user, board, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param str board: Private Leaderboard ID. (required)
        :param str language: Filter by language name.
        :param str country_code: Filter by two-character country code.
        :param int page: Page number for paginated results.
        :return: PrivateLeaderboardLeadersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_private_leaderboard_leaders_with_http_info(user, board, **kwargs)  # noqa: E501
        else:
            (data) = self.get_private_leaderboard_leaders_with_http_info(user, board, **kwargs)  # noqa: E501
            return data

    def get_private_leaderboard_leaders_with_http_info(self, user, board, **kwargs):  # noqa: E501
        """Get Private Leaderboard Leaders  # noqa: E501

        Retrieve the ranked list of members within a specific private leaderboard.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_private_leaderboard_leaders_with_http_info(user, board, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param str board: Private Leaderboard ID. (required)
        :param str language: Filter by language name.
        :param str country_code: Filter by two-character country code.
        :param int page: Page number for paginated results.
        :return: PrivateLeaderboardLeadersResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user', 'board', 'language', 'country_code', 'page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_private_leaderboard_leaders" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user' is set
        if ('user' not in params or
                params['user'] is None):
            raise ValueError("Missing the required parameter `user` when calling `get_private_leaderboard_leaders`")  # noqa: E501
        # verify the required parameter 'board' is set
        if ('board' not in params or
                params['board'] is None):
            raise ValueError("Missing the required parameter `board` when calling `get_private_leaderboard_leaders`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user' in params:
            path_params['user'] = params['user']  # noqa: E501
        if 'board' in params:
            path_params['board'] = params['board']  # noqa: E501

        query_params = []
        if 'language' in params:
            query_params.append(('language', params['language']))  # noqa: E501
        if 'country_code' in params:
            query_params.append(('country_code', params['country_code']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/{user}/leaderboards/{board}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PrivateLeaderboardLeadersResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_current_user_private_leaderboards(self, **kwargs):  # noqa: E501
        """List Current User Private Leaderboards  # noqa: E501

        Retrieve a list of private leaderboards the current user is a member of.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_current_user_private_leaderboards(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Page number for paginated results.
        :return: PrivateLeaderboardsListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_current_user_private_leaderboards_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.list_current_user_private_leaderboards_with_http_info(**kwargs)  # noqa: E501
            return data

    def list_current_user_private_leaderboards_with_http_info(self, **kwargs):  # noqa: E501
        """List Current User Private Leaderboards  # noqa: E501

        Retrieve a list of private leaderboards the current user is a member of.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_current_user_private_leaderboards_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: Page number for paginated results.
        :return: PrivateLeaderboardsListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_current_user_private_leaderboards" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/current/leaderboards', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PrivateLeaderboardsListResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_private_leaderboards(self, user, **kwargs):  # noqa: E501
        """List User Private Leaderboards  # noqa: E501

        Retrieve a list of private leaderboards the user is a member of.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_private_leaderboards(user, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param int page: Page number for paginated results.
        :return: PrivateLeaderboardsListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_private_leaderboards_with_http_info(user, **kwargs)  # noqa: E501
        else:
            (data) = self.list_private_leaderboards_with_http_info(user, **kwargs)  # noqa: E501
            return data

    def list_private_leaderboards_with_http_info(self, user, **kwargs):  # noqa: E501
        """List User Private Leaderboards  # noqa: E501

        Retrieve a list of private leaderboards the user is a member of.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_private_leaderboards_with_http_info(user, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param int page: Page number for paginated results.
        :return: PrivateLeaderboardsListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user', 'page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_private_leaderboards" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user' is set
        if ('user' not in params or
                params['user'] is None):
            raise ValueError("Missing the required parameter `user` when calling `list_private_leaderboards`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user' in params:
            path_params['user'] = params['user']  # noqa: E501

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/{user}/leaderboards', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PrivateLeaderboardsListResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
