# coding: utf-8

"""
    WakaTime API

    REST API for accessing your WakaTime coding activity stats. - Uses GET for retrieval, POST/PUT/PATCH for modification. - All requests must use HTTPS. - Responses are JSON objects. Data is in the `data` key, errors in `error` or `errors`. - Refer to WakaTime usage guidelines when using the trademark or logo.   # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from wakatime_api.api_client import ApiClient


class StatsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_aggregate_stats(self, range, **kwargs):  # noqa: E501
        """Get Aggregate Stats  # noqa: E501

        Retrieve aggregated statistics for all WakaTime users over a specific range ('last_7_days' or 'YYYY'). Uses default public profile settings.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_aggregate_stats(range, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str range: Time range ('last_7_days' or a year like '2023'). (required)
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_aggregate_stats_with_http_info(range, **kwargs)  # noqa: E501
        else:
            (data) = self.get_aggregate_stats_with_http_info(range, **kwargs)  # noqa: E501
            return data

    def get_aggregate_stats_with_http_info(self, range, **kwargs):  # noqa: E501
        """Get Aggregate Stats  # noqa: E501

        Retrieve aggregated statistics for all WakaTime users over a specific range ('last_7_days' or 'YYYY'). Uses default public profile settings.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_aggregate_stats_with_http_info(range, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str range: Time range ('last_7_days' or a year like '2023'). (required)
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['range']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_aggregate_stats" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'range' is set
        if ('range' not in params or
                params['range'] is None):
            raise ValueError("Missing the required parameter `range` when calling `get_aggregate_stats`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'range' in params:
            path_params['range'] = params['range']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/stats/{range}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2008',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_all_time_since_today(self, user, **kwargs):  # noqa: E501
        """Get All Time Since Today  # noqa: E501

        Retrieve the total time logged since the user account was created. Available even for Free accounts.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_time_since_today(user, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param str project: Filter by project name.
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_all_time_since_today_with_http_info(user, **kwargs)  # noqa: E501
        else:
            (data) = self.get_all_time_since_today_with_http_info(user, **kwargs)  # noqa: E501
            return data

    def get_all_time_since_today_with_http_info(self, user, **kwargs):  # noqa: E501
        """Get All Time Since Today  # noqa: E501

        Retrieve the total time logged since the user account was created. Available even for Free accounts.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_time_since_today_with_http_info(user, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param str project: Filter by project name.
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user', 'project']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_time_since_today" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user' is set
        if ('user' not in params or
                params['user'] is None):
            raise ValueError("Missing the required parameter `user` when calling `get_all_time_since_today`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user' in params:
            path_params['user'] = params['user']  # noqa: E501

        query_params = []
        if 'project' in params:
            query_params.append(('project', params['project']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/{user}/all_time_since_today', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse200',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_current_user_all_time_since_today(self, **kwargs):  # noqa: E501
        """Get Current User's All Time Since Today  # noqa: E501

        Retrieve the total time logged for the currently authenticated user since their account was created.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_all_time_since_today(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str project: Filter by project name.
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_current_user_all_time_since_today_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_current_user_all_time_since_today_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_current_user_all_time_since_today_with_http_info(self, **kwargs):  # noqa: E501
        """Get Current User's All Time Since Today  # noqa: E501

        Retrieve the total time logged for the currently authenticated user since their account was created.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_all_time_since_today_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str project: Filter by project name.
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_current_user_all_time_since_today" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'project' in params:
            query_params.append(('project', params['project']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/current/all_time_since_today', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse200',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_current_user_stats_default_range(self, **kwargs):  # noqa: E501
        """Get Current User Stats (Default Range)  # noqa: E501

        Retrieve coding activity statistics for the current user over their public profile's default time range. Check `is_up_to_date`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_stats_default_range(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_current_user_stats_default_range_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_current_user_stats_default_range_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_current_user_stats_default_range_with_http_info(self, **kwargs):  # noqa: E501
        """Get Current User Stats (Default Range)  # noqa: E501

        Retrieve coding activity statistics for the current user over their public profile's default time range. Check `is_up_to_date`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_stats_default_range_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['timeout', 'writes_only']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_current_user_stats_default_range" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'timeout' in params:
            query_params.append(('timeout', params['timeout']))  # noqa: E501
        if 'writes_only' in params:
            query_params.append(('writes_only', params['writes_only']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/current/stats', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_current_user_stats_for_range(self, range, **kwargs):  # noqa: E501
        """Get Current User Stats (Specific Range)  # noqa: E501

        Retrieve coding activity statistics for the current user over a specific time range. Check `is_up_to_date`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_stats_for_range(range, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str range: Time range for stats or insights (e.g., 'last_7_days', 'last_30_days', 'last_6_months', 'last_year', 'all_time', 'YYYY', 'YYYY-MM'). For aggregate stats, 'last_7_days' or 'YYYY'. (required)
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_current_user_stats_for_range_with_http_info(range, **kwargs)  # noqa: E501
        else:
            (data) = self.get_current_user_stats_for_range_with_http_info(range, **kwargs)  # noqa: E501
            return data

    def get_current_user_stats_for_range_with_http_info(self, range, **kwargs):  # noqa: E501
        """Get Current User Stats (Specific Range)  # noqa: E501

        Retrieve coding activity statistics for the current user over a specific time range. Check `is_up_to_date`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_stats_for_range_with_http_info(range, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str range: Time range for stats or insights (e.g., 'last_7_days', 'last_30_days', 'last_6_months', 'last_year', 'all_time', 'YYYY', 'YYYY-MM'). For aggregate stats, 'last_7_days' or 'YYYY'. (required)
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['range', 'timeout', 'writes_only']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_current_user_stats_for_range" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'range' is set
        if ('range' not in params or
                params['range'] is None):
            raise ValueError("Missing the required parameter `range` when calling `get_current_user_stats_for_range`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'range' in params:
            path_params['range'] = params['range']  # noqa: E501

        query_params = []
        if 'timeout' in params:
            query_params.append(('timeout', params['timeout']))  # noqa: E501
        if 'writes_only' in params:
            query_params.append(('writes_only', params['writes_only']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/current/stats/{range}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_stats_default_range(self, user, **kwargs):  # noqa: E501
        """Get User Stats (Default Range)  # noqa: E501

        Retrieve coding activity statistics for the user over their public profile's default time range. Check `is_up_to_date`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_stats_default_range(user, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_stats_default_range_with_http_info(user, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_stats_default_range_with_http_info(user, **kwargs)  # noqa: E501
            return data

    def get_user_stats_default_range_with_http_info(self, user, **kwargs):  # noqa: E501
        """Get User Stats (Default Range)  # noqa: E501

        Retrieve coding activity statistics for the user over their public profile's default time range. Check `is_up_to_date`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_stats_default_range_with_http_info(user, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user', 'timeout', 'writes_only']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_stats_default_range" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user' is set
        if ('user' not in params or
                params['user'] is None):
            raise ValueError("Missing the required parameter `user` when calling `get_user_stats_default_range`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user' in params:
            path_params['user'] = params['user']  # noqa: E501

        query_params = []
        if 'timeout' in params:
            query_params.append(('timeout', params['timeout']))  # noqa: E501
        if 'writes_only' in params:
            query_params.append(('writes_only', params['writes_only']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/{user}/stats', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_stats_for_range(self, user, range, **kwargs):  # noqa: E501
        """Get User Stats (Specific Range)  # noqa: E501

        Retrieve coding activity statistics for the user over a specific time range. Check `is_up_to_date`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_stats_for_range(user, range, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param str range: Time range for stats or insights (e.g., 'last_7_days', 'last_30_days', 'last_6_months', 'last_year', 'all_time', 'YYYY', 'YYYY-MM'). For aggregate stats, 'last_7_days' or 'YYYY'. (required)
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_stats_for_range_with_http_info(user, range, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_stats_for_range_with_http_info(user, range, **kwargs)  # noqa: E501
            return data

    def get_user_stats_for_range_with_http_info(self, user, range, **kwargs):  # noqa: E501
        """Get User Stats (Specific Range)  # noqa: E501

        Retrieve coding activity statistics for the user over a specific time range. Check `is_up_to_date`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_stats_for_range_with_http_info(user, range, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param str range: Time range for stats or insights (e.g., 'last_7_days', 'last_30_days', 'last_6_months', 'last_year', 'all_time', 'YYYY', 'YYYY-MM'). For aggregate stats, 'last_7_days' or 'YYYY'. (required)
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user', 'range', 'timeout', 'writes_only']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_stats_for_range" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user' is set
        if ('user' not in params or
                params['user'] is None):
            raise ValueError("Missing the required parameter `user` when calling `get_user_stats_for_range`")  # noqa: E501
        # verify the required parameter 'range' is set
        if ('range' not in params or
                params['range'] is None):
            raise ValueError("Missing the required parameter `range` when calling `get_user_stats_for_range`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user' in params:
            path_params['user'] = params['user']  # noqa: E501
        if 'range' in params:
            path_params['range'] = params['range']  # noqa: E501

        query_params = []
        if 'timeout' in params:
            query_params.append(('timeout', params['timeout']))  # noqa: E501
        if 'writes_only' in params:
            query_params.append(('writes_only', params['writes_only']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/{user}/stats/{range}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
