# coding: utf-8

"""
    WakaTime API

    REST API for accessing your WakaTime coding activity stats. - Uses GET for retrieval, POST/PUT/PATCH for modification. - All requests must use HTTPS. - Responses are JSON objects. Data is in the `data` key, errors in `error` or `errors`. - Refer to WakaTime usage guidelines when using the trademark or logo.   # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from wakatime_api.api_client import ApiClient


class SummariesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_current_user_status_bar_summary(self, **kwargs):  # noqa: E501
        """Get Current User Status Bar Summary (Today)  # noqa: E501

        Retrieve today's coding activity summary for the current user, optimized for status bar display. Uses cached data.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_status_bar_summary(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: StatusBarResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_current_user_status_bar_summary_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_current_user_status_bar_summary_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_current_user_status_bar_summary_with_http_info(self, **kwargs):  # noqa: E501
        """Get Current User Status Bar Summary (Today)  # noqa: E501

        Retrieve today's coding activity summary for the current user, optimized for status bar display. Uses cached data.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_status_bar_summary_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: StatusBarResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_current_user_status_bar_summary" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/current/status_bar/today', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='StatusBarResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_current_user_summaries(self, start, end, **kwargs):  # noqa: E501
        """Get Current User Summaries  # noqa: E501

        Retrieve daily summaries of coding activity for the current user over a specified date range.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_summaries(start, end, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param date start: Start date of the time range (YYYY-MM-DD). (required)
        :param date end: End date of the time range (YYYY-MM-DD). (required)
        :param str project: Filter by project name.
        :param str branches: Filter by comma-separated list of branch names.
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :param str timezone: Override the user's timezone (Olson format, e.g., 'America/Los_Angeles').
        :param str range: Alternative way to specify date range (e.g., 'Today', 'Last 7 Days'). Overrides start/end if provided.
        :return: SummariesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_current_user_summaries_with_http_info(start, end, **kwargs)  # noqa: E501
        else:
            (data) = self.get_current_user_summaries_with_http_info(start, end, **kwargs)  # noqa: E501
            return data

    def get_current_user_summaries_with_http_info(self, start, end, **kwargs):  # noqa: E501
        """Get Current User Summaries  # noqa: E501

        Retrieve daily summaries of coding activity for the current user over a specified date range.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_current_user_summaries_with_http_info(start, end, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param date start: Start date of the time range (YYYY-MM-DD). (required)
        :param date end: End date of the time range (YYYY-MM-DD). (required)
        :param str project: Filter by project name.
        :param str branches: Filter by comma-separated list of branch names.
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :param str timezone: Override the user's timezone (Olson format, e.g., 'America/Los_Angeles').
        :param str range: Alternative way to specify date range (e.g., 'Today', 'Last 7 Days'). Overrides start/end if provided.
        :return: SummariesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['start', 'end', 'project', 'branches', 'timeout', 'writes_only', 'timezone', 'range']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_current_user_summaries" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'start' is set
        if ('start' not in params or
                params['start'] is None):
            raise ValueError("Missing the required parameter `start` when calling `get_current_user_summaries`")  # noqa: E501
        # verify the required parameter 'end' is set
        if ('end' not in params or
                params['end'] is None):
            raise ValueError("Missing the required parameter `end` when calling `get_current_user_summaries`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'start' in params:
            query_params.append(('start', params['start']))  # noqa: E501
        if 'end' in params:
            query_params.append(('end', params['end']))  # noqa: E501
        if 'project' in params:
            query_params.append(('project', params['project']))  # noqa: E501
        if 'branches' in params:
            query_params.append(('branches', params['branches']))  # noqa: E501
        if 'timeout' in params:
            query_params.append(('timeout', params['timeout']))  # noqa: E501
        if 'writes_only' in params:
            query_params.append(('writes_only', params['writes_only']))  # noqa: E501
        if 'timezone' in params:
            query_params.append(('timezone', params['timezone']))  # noqa: E501
        if 'range' in params:
            query_params.append(('range', params['range']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/current/summaries', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SummariesResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_status_bar_summary(self, user, **kwargs):  # noqa: E501
        """Get User Status Bar Summary (Today)  # noqa: E501

        Retrieve today's coding activity summary, optimized for status bar display. Uses cached data and may return empty structure initially.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_status_bar_summary(user, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :return: StatusBarResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_status_bar_summary_with_http_info(user, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_status_bar_summary_with_http_info(user, **kwargs)  # noqa: E501
            return data

    def get_user_status_bar_summary_with_http_info(self, user, **kwargs):  # noqa: E501
        """Get User Status Bar Summary (Today)  # noqa: E501

        Retrieve today's coding activity summary, optimized for status bar display. Uses cached data and may return empty structure initially.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_status_bar_summary_with_http_info(user, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :return: StatusBarResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_status_bar_summary" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user' is set
        if ('user' not in params or
                params['user'] is None):
            raise ValueError("Missing the required parameter `user` when calling `get_user_status_bar_summary`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user' in params:
            path_params['user'] = params['user']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/{user}/status_bar/today', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='StatusBarResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_summaries(self, user, start, end, **kwargs):  # noqa: E501
        """Get User Summaries  # noqa: E501

        Retrieve daily summaries of coding activity for a user over a specified date range.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_summaries(user, start, end, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param date start: Start date of the time range (YYYY-MM-DD). (required)
        :param date end: End date of the time range (YYYY-MM-DD). (required)
        :param str project: Filter by project name.
        :param str branches: Filter by comma-separated list of branch names.
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :param str timezone: Override the user's timezone (Olson format, e.g., 'America/Los_Angeles').
        :param str range: Alternative way to specify date range (e.g., 'Today', 'Last 7 Days'). Overrides start/end if provided.
        :return: SummariesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_summaries_with_http_info(user, start, end, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_summaries_with_http_info(user, start, end, **kwargs)  # noqa: E501
            return data

    def get_user_summaries_with_http_info(self, user, start, end, **kwargs):  # noqa: E501
        """Get User Summaries  # noqa: E501

        Retrieve daily summaries of coding activity for a user over a specified date range.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_summaries_with_http_info(user, start, end, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user: User ID or 'current' for the authenticated user. (required)
        :param date start: Start date of the time range (YYYY-MM-DD). (required)
        :param date end: End date of the time range (YYYY-MM-DD). (required)
        :param str project: Filter by project name.
        :param str branches: Filter by comma-separated list of branch names.
        :param int timeout: Override the user's keystroke timeout setting (in minutes).
        :param bool writes_only: Override the user's writes_only setting.
        :param str timezone: Override the user's timezone (Olson format, e.g., 'America/Los_Angeles').
        :param str range: Alternative way to specify date range (e.g., 'Today', 'Last 7 Days'). Overrides start/end if provided.
        :return: SummariesResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user', 'start', 'end', 'project', 'branches', 'timeout', 'writes_only', 'timezone', 'range']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_summaries" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user' is set
        if ('user' not in params or
                params['user'] is None):
            raise ValueError("Missing the required parameter `user` when calling `get_user_summaries`")  # noqa: E501
        # verify the required parameter 'start' is set
        if ('start' not in params or
                params['start'] is None):
            raise ValueError("Missing the required parameter `start` when calling `get_user_summaries`")  # noqa: E501
        # verify the required parameter 'end' is set
        if ('end' not in params or
                params['end'] is None):
            raise ValueError("Missing the required parameter `end` when calling `get_user_summaries`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'user' in params:
            path_params['user'] = params['user']  # noqa: E501

        query_params = []
        if 'start' in params:
            query_params.append(('start', params['start']))  # noqa: E501
        if 'end' in params:
            query_params.append(('end', params['end']))  # noqa: E501
        if 'project' in params:
            query_params.append(('project', params['project']))  # noqa: E501
        if 'branches' in params:
            query_params.append(('branches', params['branches']))  # noqa: E501
        if 'timeout' in params:
            query_params.append(('timeout', params['timeout']))  # noqa: E501
        if 'writes_only' in params:
            query_params.append(('writes_only', params['writes_only']))  # noqa: E501
        if 'timezone' in params:
            query_params.append(('timezone', params['timezone']))  # noqa: E501
        if 'range' in params:
            query_params.append(('range', params['range']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyQuery', 'basicAuth', 'oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/users/{user}/summaries', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SummariesResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
