# coding: utf-8

"""
    WakaTime API

    REST API for accessing your WakaTime coding activity stats. - Uses GET for retrieval, POST/PUT/PATCH for modification. - All requests must use HTTPS. - Responses are JSON objects. Data is in the `data` key, errors in `error` or `errors`. - Refer to WakaTime usage guidelines when using the trademark or logo.   # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AllTimeSinceToday(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'daily_average': 'float',
        'decimal': 'str',
        'digital': 'str',
        'is_up_to_date': 'bool',
        'percent_calculated': 'int',
        'range': 'Range',
        'text': 'str',
        'timeout': 'int',
        'total_seconds': 'float'
    }

    attribute_map = {
        'daily_average': 'daily_average',
        'decimal': 'decimal',
        'digital': 'digital',
        'is_up_to_date': 'is_up_to_date',
        'percent_calculated': 'percent_calculated',
        'range': 'range',
        'text': 'text',
        'timeout': 'timeout',
        'total_seconds': 'total_seconds'
    }

    def __init__(self, daily_average=None, decimal=None, digital=None, is_up_to_date=None, percent_calculated=None, range=None, text=None, timeout=None, total_seconds=None):  # noqa: E501
        """AllTimeSinceToday - a model defined in Swagger"""  # noqa: E501
        self._daily_average = None
        self._decimal = None
        self._digital = None
        self._is_up_to_date = None
        self._percent_calculated = None
        self._range = None
        self._text = None
        self._timeout = None
        self._total_seconds = None
        self.discriminator = None
        if daily_average is not None:
            self.daily_average = daily_average
        if decimal is not None:
            self.decimal = decimal
        if digital is not None:
            self.digital = digital
        if is_up_to_date is not None:
            self.is_up_to_date = is_up_to_date
        if percent_calculated is not None:
            self.percent_calculated = percent_calculated
        if range is not None:
            self.range = range
        if text is not None:
            self.text = text
        if timeout is not None:
            self.timeout = timeout
        if total_seconds is not None:
            self.total_seconds = total_seconds

    @property
    def daily_average(self):
        """Gets the daily_average of this AllTimeSinceToday.  # noqa: E501

        Average coding activity per day (seconds).  # noqa: E501

        :return: The daily_average of this AllTimeSinceToday.  # noqa: E501
        :rtype: float
        """
        return self._daily_average

    @daily_average.setter
    def daily_average(self, daily_average):
        """Sets the daily_average of this AllTimeSinceToday.

        Average coding activity per day (seconds).  # noqa: E501

        :param daily_average: The daily_average of this AllTimeSinceToday.  # noqa: E501
        :type: float
        """

        self._daily_average = daily_average

    @property
    def decimal(self):
        """Gets the decimal of this AllTimeSinceToday.  # noqa: E501

        Total coding activity in decimal format.  # noqa: E501

        :return: The decimal of this AllTimeSinceToday.  # noqa: E501
        :rtype: str
        """
        return self._decimal

    @decimal.setter
    def decimal(self, decimal):
        """Sets the decimal of this AllTimeSinceToday.

        Total coding activity in decimal format.  # noqa: E501

        :param decimal: The decimal of this AllTimeSinceToday.  # noqa: E501
        :type: str
        """

        self._decimal = decimal

    @property
    def digital(self):
        """Gets the digital of this AllTimeSinceToday.  # noqa: E501

        Total coding activity in digital clock format.  # noqa: E501

        :return: The digital of this AllTimeSinceToday.  # noqa: E501
        :rtype: str
        """
        return self._digital

    @digital.setter
    def digital(self, digital):
        """Sets the digital of this AllTimeSinceToday.

        Total coding activity in digital clock format.  # noqa: E501

        :param digital: The digital of this AllTimeSinceToday.  # noqa: E501
        :type: str
        """

        self._digital = digital

    @property
    def is_up_to_date(self):
        """Gets the is_up_to_date of this AllTimeSinceToday.  # noqa: E501

        True if stats are up-to-date.  # noqa: E501

        :return: The is_up_to_date of this AllTimeSinceToday.  # noqa: E501
        :rtype: bool
        """
        return self._is_up_to_date

    @is_up_to_date.setter
    def is_up_to_date(self, is_up_to_date):
        """Sets the is_up_to_date of this AllTimeSinceToday.

        True if stats are up-to-date.  # noqa: E501

        :param is_up_to_date: The is_up_to_date of this AllTimeSinceToday.  # noqa: E501
        :type: bool
        """

        self._is_up_to_date = is_up_to_date

    @property
    def percent_calculated(self):
        """Gets the percent_calculated of this AllTimeSinceToday.  # noqa: E501

        Percentage completion of stats calculation (0-100).  # noqa: E501

        :return: The percent_calculated of this AllTimeSinceToday.  # noqa: E501
        :rtype: int
        """
        return self._percent_calculated

    @percent_calculated.setter
    def percent_calculated(self, percent_calculated):
        """Sets the percent_calculated of this AllTimeSinceToday.

        Percentage completion of stats calculation (0-100).  # noqa: E501

        :param percent_calculated: The percent_calculated of this AllTimeSinceToday.  # noqa: E501
        :type: int
        """

        self._percent_calculated = percent_calculated

    @property
    def range(self):
        """Gets the range of this AllTimeSinceToday.  # noqa: E501


        :return: The range of this AllTimeSinceToday.  # noqa: E501
        :rtype: Range
        """
        return self._range

    @range.setter
    def range(self, range):
        """Sets the range of this AllTimeSinceToday.


        :param range: The range of this AllTimeSinceToday.  # noqa: E501
        :type: Range
        """

        self._range = range

    @property
    def text(self):
        """Gets the text of this AllTimeSinceToday.  # noqa: E501

        Total time logged since account creation (human-readable).  # noqa: E501

        :return: The text of this AllTimeSinceToday.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this AllTimeSinceToday.

        Total time logged since account creation (human-readable).  # noqa: E501

        :param text: The text of this AllTimeSinceToday.  # noqa: E501
        :type: str
        """

        self._text = text

    @property
    def timeout(self):
        """Gets the timeout of this AllTimeSinceToday.  # noqa: E501

        Keystroke timeout setting in minutes.  # noqa: E501

        :return: The timeout of this AllTimeSinceToday.  # noqa: E501
        :rtype: int
        """
        return self._timeout

    @timeout.setter
    def timeout(self, timeout):
        """Sets the timeout of this AllTimeSinceToday.

        Keystroke timeout setting in minutes.  # noqa: E501

        :param timeout: The timeout of this AllTimeSinceToday.  # noqa: E501
        :type: int
        """

        self._timeout = timeout

    @property
    def total_seconds(self):
        """Gets the total_seconds of this AllTimeSinceToday.  # noqa: E501

        Total seconds logged since account creation.  # noqa: E501

        :return: The total_seconds of this AllTimeSinceToday.  # noqa: E501
        :rtype: float
        """
        return self._total_seconds

    @total_seconds.setter
    def total_seconds(self, total_seconds):
        """Sets the total_seconds of this AllTimeSinceToday.

        Total seconds logged since account creation.  # noqa: E501

        :param total_seconds: The total_seconds of this AllTimeSinceToday.  # noqa: E501
        :type: float
        """

        self._total_seconds = total_seconds

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AllTimeSinceToday, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AllTimeSinceToday):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
