# coding: utf-8

"""
    WakaTime API

    REST API for accessing your WakaTime coding activity stats. - Uses GET for retrieval, POST/PUT/PATCH for modification. - All requests must use HTTPS. - Responses are JSON objects. Data is in the `data` key, errors in `error` or `errors`. - Refer to WakaTime usage guidelines when using the trademark or logo.   # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Duration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'project': 'str',
        'time': 'float',
        'duration': 'float'
    }

    attribute_map = {
        'project': 'project',
        'time': 'time',
        'duration': 'duration'
    }

    def __init__(self, project=None, time=None, duration=None):  # noqa: E501
        """Duration - a model defined in Swagger"""  # noqa: E501
        self._project = None
        self._time = None
        self._duration = None
        self.discriminator = None
        if project is not None:
            self.project = project
        if time is not None:
            self.time = time
        if duration is not None:
            self.duration = duration

    @property
    def project(self):
        """Gets the project of this Duration.  # noqa: E501


        :return: The project of this Duration.  # noqa: E501
        :rtype: str
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this Duration.


        :param project: The project of this Duration.  # noqa: E501
        :type: str
        """

        self._project = project

    @property
    def time(self):
        """Gets the time of this Duration.  # noqa: E501

        Start of duration as UNIX epoch timestamp.  # noqa: E501

        :return: The time of this Duration.  # noqa: E501
        :rtype: float
        """
        return self._time

    @time.setter
    def time(self, time):
        """Sets the time of this Duration.

        Start of duration as UNIX epoch timestamp.  # noqa: E501

        :param time: The time of this Duration.  # noqa: E501
        :type: float
        """

        self._time = time

    @property
    def duration(self):
        """Gets the duration of this Duration.  # noqa: E501

        Length of duration in seconds.  # noqa: E501

        :return: The duration of this Duration.  # noqa: E501
        :rtype: float
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """Sets the duration of this Duration.

        Length of duration in seconds.  # noqa: E501

        :param duration: The duration of this Duration.  # noqa: E501
        :type: float
        """

        self._duration = duration

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Duration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Duration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
