# coding: utf-8

"""
    WakaTime API

    REST API for accessing your WakaTime coding activity stats. - Uses GET for retrieval, POST/PUT/PATCH for modification. - All requests must use HTTPS. - Responses are JSON objects. Data is in the `data` key, errors in `error` or `errors`. - Refer to WakaTime usage guidelines when using the trademark or logo.   # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class LeadersResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'current_user': 'LeadersResponseCurrentUser',
        'data': 'list[Leader]',
        'page': 'int',
        'total_pages': 'int',
        'range': 'Range',
        'language': 'str',
        'is_hireable': 'bool',
        'country_code': 'str',
        'modified_at': 'datetime',
        'timeout': 'int',
        'writes_only': 'bool'
    }

    attribute_map = {
        'current_user': 'current_user',
        'data': 'data',
        'page': 'page',
        'total_pages': 'total_pages',
        'range': 'range',
        'language': 'language',
        'is_hireable': 'is_hireable',
        'country_code': 'country_code',
        'modified_at': 'modified_at',
        'timeout': 'timeout',
        'writes_only': 'writes_only'
    }

    def __init__(self, current_user=None, data=None, page=None, total_pages=None, range=None, language=None, is_hireable=None, country_code=None, modified_at=None, timeout=None, writes_only=None):  # noqa: E501
        """LeadersResponse - a model defined in Swagger"""  # noqa: E501
        self._current_user = None
        self._data = None
        self._page = None
        self._total_pages = None
        self._range = None
        self._language = None
        self._is_hireable = None
        self._country_code = None
        self._modified_at = None
        self._timeout = None
        self._writes_only = None
        self.discriminator = None
        if current_user is not None:
            self.current_user = current_user
        if data is not None:
            self.data = data
        if page is not None:
            self.page = page
        if total_pages is not None:
            self.total_pages = total_pages
        if range is not None:
            self.range = range
        if language is not None:
            self.language = language
        if is_hireable is not None:
            self.is_hireable = is_hireable
        if country_code is not None:
            self.country_code = country_code
        if modified_at is not None:
            self.modified_at = modified_at
        if timeout is not None:
            self.timeout = timeout
        if writes_only is not None:
            self.writes_only = writes_only

    @property
    def current_user(self):
        """Gets the current_user of this LeadersResponse.  # noqa: E501


        :return: The current_user of this LeadersResponse.  # noqa: E501
        :rtype: LeadersResponseCurrentUser
        """
        return self._current_user

    @current_user.setter
    def current_user(self, current_user):
        """Sets the current_user of this LeadersResponse.


        :param current_user: The current_user of this LeadersResponse.  # noqa: E501
        :type: LeadersResponseCurrentUser
        """

        self._current_user = current_user

    @property
    def data(self):
        """Gets the data of this LeadersResponse.  # noqa: E501


        :return: The data of this LeadersResponse.  # noqa: E501
        :rtype: list[Leader]
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this LeadersResponse.


        :param data: The data of this LeadersResponse.  # noqa: E501
        :type: list[Leader]
        """

        self._data = data

    @property
    def page(self):
        """Gets the page of this LeadersResponse.  # noqa: E501


        :return: The page of this LeadersResponse.  # noqa: E501
        :rtype: int
        """
        return self._page

    @page.setter
    def page(self, page):
        """Sets the page of this LeadersResponse.


        :param page: The page of this LeadersResponse.  # noqa: E501
        :type: int
        """

        self._page = page

    @property
    def total_pages(self):
        """Gets the total_pages of this LeadersResponse.  # noqa: E501


        :return: The total_pages of this LeadersResponse.  # noqa: E501
        :rtype: int
        """
        return self._total_pages

    @total_pages.setter
    def total_pages(self, total_pages):
        """Sets the total_pages of this LeadersResponse.


        :param total_pages: The total_pages of this LeadersResponse.  # noqa: E501
        :type: int
        """

        self._total_pages = total_pages

    @property
    def range(self):
        """Gets the range of this LeadersResponse.  # noqa: E501


        :return: The range of this LeadersResponse.  # noqa: E501
        :rtype: Range
        """
        return self._range

    @range.setter
    def range(self, range):
        """Sets the range of this LeadersResponse.


        :param range: The range of this LeadersResponse.  # noqa: E501
        :type: Range
        """

        self._range = range

    @property
    def language(self):
        """Gets the language of this LeadersResponse.  # noqa: E501


        :return: The language of this LeadersResponse.  # noqa: E501
        :rtype: str
        """
        return self._language

    @language.setter
    def language(self, language):
        """Sets the language of this LeadersResponse.


        :param language: The language of this LeadersResponse.  # noqa: E501
        :type: str
        """

        self._language = language

    @property
    def is_hireable(self):
        """Gets the is_hireable of this LeadersResponse.  # noqa: E501


        :return: The is_hireable of this LeadersResponse.  # noqa: E501
        :rtype: bool
        """
        return self._is_hireable

    @is_hireable.setter
    def is_hireable(self, is_hireable):
        """Sets the is_hireable of this LeadersResponse.


        :param is_hireable: The is_hireable of this LeadersResponse.  # noqa: E501
        :type: bool
        """

        self._is_hireable = is_hireable

    @property
    def country_code(self):
        """Gets the country_code of this LeadersResponse.  # noqa: E501


        :return: The country_code of this LeadersResponse.  # noqa: E501
        :rtype: str
        """
        return self._country_code

    @country_code.setter
    def country_code(self, country_code):
        """Sets the country_code of this LeadersResponse.


        :param country_code: The country_code of this LeadersResponse.  # noqa: E501
        :type: str
        """

        self._country_code = country_code

    @property
    def modified_at(self):
        """Gets the modified_at of this LeadersResponse.  # noqa: E501


        :return: The modified_at of this LeadersResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._modified_at

    @modified_at.setter
    def modified_at(self, modified_at):
        """Sets the modified_at of this LeadersResponse.


        :param modified_at: The modified_at of this LeadersResponse.  # noqa: E501
        :type: datetime
        """

        self._modified_at = modified_at

    @property
    def timeout(self):
        """Gets the timeout of this LeadersResponse.  # noqa: E501


        :return: The timeout of this LeadersResponse.  # noqa: E501
        :rtype: int
        """
        return self._timeout

    @timeout.setter
    def timeout(self, timeout):
        """Sets the timeout of this LeadersResponse.


        :param timeout: The timeout of this LeadersResponse.  # noqa: E501
        :type: int
        """

        self._timeout = timeout

    @property
    def writes_only(self):
        """Gets the writes_only of this LeadersResponse.  # noqa: E501


        :return: The writes_only of this LeadersResponse.  # noqa: E501
        :rtype: bool
        """
        return self._writes_only

    @writes_only.setter
    def writes_only(self, writes_only):
        """Sets the writes_only of this LeadersResponse.


        :param writes_only: The writes_only of this LeadersResponse.  # noqa: E501
        :type: bool
        """

        self._writes_only = writes_only

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LeadersResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LeadersResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
