# coding: utf-8

"""
    WakaTime API

    REST API for accessing your WakaTime coding activity stats. - Uses GET for retrieval, POST/PUT/PATCH for modification. - All requests must use HTTPS. - Responses are JSON objects. Data is in the `data` key, errors in `error` or `errors`. - Refer to WakaTime usage guidelines when using the trademark or logo.   # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SummariesResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'data': 'list[Summary]',
        'cumulative_total': 'CumulativeTotal',
        'daily_average': 'DailyAverage',
        'start': 'datetime',
        'end': 'datetime'
    }

    attribute_map = {
        'data': 'data',
        'cumulative_total': 'cumulative_total',
        'daily_average': 'daily_average',
        'start': 'start',
        'end': 'end'
    }

    def __init__(self, data=None, cumulative_total=None, daily_average=None, start=None, end=None):  # noqa: E501
        """SummariesResponse - a model defined in Swagger"""  # noqa: E501
        self._data = None
        self._cumulative_total = None
        self._daily_average = None
        self._start = None
        self._end = None
        self.discriminator = None
        if data is not None:
            self.data = data
        if cumulative_total is not None:
            self.cumulative_total = cumulative_total
        if daily_average is not None:
            self.daily_average = daily_average
        if start is not None:
            self.start = start
        if end is not None:
            self.end = end

    @property
    def data(self):
        """Gets the data of this SummariesResponse.  # noqa: E501


        :return: The data of this SummariesResponse.  # noqa: E501
        :rtype: list[Summary]
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this SummariesResponse.


        :param data: The data of this SummariesResponse.  # noqa: E501
        :type: list[Summary]
        """

        self._data = data

    @property
    def cumulative_total(self):
        """Gets the cumulative_total of this SummariesResponse.  # noqa: E501


        :return: The cumulative_total of this SummariesResponse.  # noqa: E501
        :rtype: CumulativeTotal
        """
        return self._cumulative_total

    @cumulative_total.setter
    def cumulative_total(self, cumulative_total):
        """Sets the cumulative_total of this SummariesResponse.


        :param cumulative_total: The cumulative_total of this SummariesResponse.  # noqa: E501
        :type: CumulativeTotal
        """

        self._cumulative_total = cumulative_total

    @property
    def daily_average(self):
        """Gets the daily_average of this SummariesResponse.  # noqa: E501


        :return: The daily_average of this SummariesResponse.  # noqa: E501
        :rtype: DailyAverage
        """
        return self._daily_average

    @daily_average.setter
    def daily_average(self, daily_average):
        """Sets the daily_average of this SummariesResponse.


        :param daily_average: The daily_average of this SummariesResponse.  # noqa: E501
        :type: DailyAverage
        """

        self._daily_average = daily_average

    @property
    def start(self):
        """Gets the start of this SummariesResponse.  # noqa: E501


        :return: The start of this SummariesResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._start

    @start.setter
    def start(self, start):
        """Sets the start of this SummariesResponse.


        :param start: The start of this SummariesResponse.  # noqa: E501
        :type: datetime
        """

        self._start = start

    @property
    def end(self):
        """Gets the end of this SummariesResponse.  # noqa: E501


        :return: The end of this SummariesResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._end

    @end.setter
    def end(self, end):
        """Sets the end of this SummariesResponse.


        :param end: The end of this SummariesResponse.  # noqa: E501
        :type: datetime
        """

        self._end = end

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SummariesResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SummariesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
